package nuggeteer_settings;

$ENV{NUGGETEER_DATA_DIR} ||= 'data';

# Where to store learned model:
our $jdb = qq($ENV{NUGGETEER_DATA_DIR}/jdbs/official-2004.jdb); 

# What to learn:
our %training_settings = (
    jfiles => [ glob qq($ENV{NUGGETEER_DATA_DIR}/official-2004/*) ],
    answerkeys => [ qq($ENV{NUGGETEER_DATA_DIR}/official-2004.answers) ],

    # Empirically optimized with threshold: use a term's inverse document
    # frequency from the corpus rather than its local frequency:
    term_weighting => "idf",

    stopwords => "keep", # Empirically optimized with threshold: keep stopwords
    ngrams => 2, # Empirically optimized with threshold: use unigrams and bigrams
    stem => 0, # Empirically optimized with threshold: do not stem words
    beta => 3,

    # Zero is infinity, none of the 2004 dataset is so big that we need to
    # cut off the training data at some nth judgement:
    max_judgement_rank => 0,

    lm_from_judgements => 0,  # Enabling this has been shown to be a bad idea.
    );

# How to use scores to decide whether a response contains a nugget:
our @decision_methods = ( 0.12 ); # A bare number is a fixed threshold
