package nuggeteer_settings;

$ENV{NUGGETEER_DATA_DIR} ||= 'data';

# Where to store learned model:
our $jdb = qq($ENV{NUGGETEER_DATA_DIR}/jdbs/official-O2006.jdb); 

# What to learn:
our %training_settings = (
    jfiles => [ glob qq($ENV{NUGGETEER_DATA_DIR}/official-O2006/*) ],
    answerkeys => [ qq($ENV{NUGGETEER_DATA_DIR}/official-O2006.answers) ],

    # Empirically optimized with threshold: use only a term's local frequency,
    # not its inverse document frequency from the corpus:
    term_weighting => "count",

    stopwords => "keep", # Empirically optimized with threshold: keep stopwords
    ngrams => 2, # Empirically optimized with threshold: use unigrams and bigrams
    stem => 1, # Empirically optimized with threshold: stem words
    beta => 3,

    # Zero is infinity, none of the O2006 dataset is so big that we need to
    # cut off the training data at some nth judgement:
    max_judgement_rank => 0,

    lm_from_judgements => 0,  # Enabling this has been shown to be a bad idea.
    );

# How to use scores to decide whether a response contains a nugget:
our @decision_methods = ( 0.14 ); # A bare number is a fixed threshold
