package nuggeteer_settings;

$ENV{NUGGETEER_DATA_DIR} ||= 'data';

# where to store learned model:
our $jdb = qq($ENV{NUGGETEER_DATA_DIR}/jdbs/P2005.jdb); 

# what to learn:
our %training_settings = (
    jfiles => [ glob qq($ENV{NUGGETEER_DATA_DIR}/official-P2005/*) ],
    answerkeys => [ qq($ENV{NUGGETEER_DATA_DIR}/official-P2005.answers) ],

    # empirically optimized with threshold: use only a term's local frequency, 
    # not its inverse document frequency from the corpus:
    term_weighting => "idf",

    stopwords => "remove", # empirically optimized with threshold: keep stopwords
    ngrams => 2, # empirically optimized with threshold: use unigrams only
    stem => 0, # empirically optimized with threshold: do not stem
    beta => 3,

    # zero is infinity, none of the 2003 dataset is so big that we need to 
    # cut off the training data at some nth judgement:
    max_judgement_rank => 0,  

    lm_from_judgements => 0,  # has been shown to be a bad idea.
    );

# how to use scores to decide whether a response contains a nugget:
our @decision_methods = ( 0.07 ); # a bare number is a fixed threshold.

    
