require 'test/unit'
require File.dirname(__FILE__) + "/executable_test_helper.rb"

class KnownDataTest < Test::Unit::TestCase

  include ExecutableTestHelper

  def test_simple_qid_nid_selection_thresholds
    output = run_executable("simple_qid_nid_selection_thresholds.rb", LEVEL_TEST_DATA_FILE)
    assert_equal({ "1001" => 0.15, "q02" => 0.15, "1003" => 0.15, 
                   "1004" => 0.15, "1005" => 0.15, "1006" => 0.15, 
                   "2001" => 0.15, "2002" => 0.15, "qid03" => 0.15, 
                   "2004" => 0.15, "2005" => 0.15, "2006" => 0.15, 
                   "3001" => 0.35 }, extract_qid_thresholds(output))
    assert_equal({ "3001" => { "7" => 0.55 } }, extract_nid_thresholds(output))
  end

  def test_simple_gl_qid_selection_thresholds
    output = run_executable("simple_gl_qid_selection_thresholds.rb", LEVEL_TEST_DATA_FILE)
    assert_equal 0.15, extract_global_threshold(output)
    assert_equal({ "3001" => 0.35 }, extract_qid_thresholds(output))
    assert_equal({ }, extract_nid_thresholds(output))
  end

  def test_simple_gl_nid_selection_thresholds
    output = run_executable("simple_gl_nid_selection_thresholds.rb", LEVEL_TEST_DATA_FILE)
    assert_equal 0.15, extract_global_threshold(output)
    assert_equal({ }, extract_qid_thresholds(output))
    assert_equal({ "3001" => { "1" => 0.35, "2" => 0.35, "3" => 0.35, 
                     "4" => 0.35, "5" => 0.35, "6" => 0.35, 
                     "7" => 0.55 } }, extract_nid_thresholds(output))
  end

  def test_simple_gl_qid_nid_selection_thresholds
    output = run_executable("simple_gl_qid_nid_selection_thresholds.rb", LEVEL_TEST_DATA_FILE)
    assert_equal 0.15, extract_global_threshold(output)
    assert_equal({ "3001" => 0.35 }, extract_qid_thresholds(output))
    assert_equal({ "3001" => { "7" => 0.55 } }, extract_nid_thresholds(output))
  end

end
