#!/usr/bin/ruby

#require 'profile'
require File.dirname(__FILE__) + "/../data_set.rb"
require File.dirname(__FILE__) + "/../environment.rb"

Environment.execute do |options|

  dataset = DataSet.parse_from_stream(STDIN, :nugget)
  dataset.verbosity = :quiet if options[:quiet]
  best_epsilon = dataset.best_epsilon

  qdataset = dataset.reallocate(:question)
  qdataset.verbosity = :quiet if options[:quiet]
  qdataset.data_groups.each do |group|
    qthresh = group.best_threshold(best_epsilon[0], best_epsilon[1])
    puts "QUESTION\t#{group.question_id}\t#{qthresh}"
    subset = DataSet.allocate(group.data_points, :nugget)
    subset.data_groups.each do |subgroup|
      if subgroup.log10_prob_fixed_epsilon_marginal_threshold(best_epsilon[0], best_epsilon[1]) > 
          subgroup.log10_prob_fixed_threshold_fixed_epsilon(qthresh, best_epsilon[0], best_epsilon[1])
        puts "nugget-level won at question #{subgroup.question_id}, nugget #{subgroup.nugget_id}." unless options[:quiet]
        puts "NUGGET\t#{subgroup.question_id}\t#{subgroup.nugget_id}\t#{subgroup.best_threshold(best_epsilon[0], best_epsilon[1])}"
      else
        puts "question-level won at question #{subgroup.question_id}, nugget #{subgroup.nugget_id}." unless options[:quiet]
      end
    end
  end

end
