require 'test/unit'
require File.dirname(__FILE__) + "/counters.rb"

class CountersTest < Test::Unit::TestCase

  def setup
    @start = Counters.new(0, 0, 3, 3)
    @one_right = @start.step_over(:no)
    @mixed_step = @one_right.step_over(:yes).step_over(:no)
    @bad_step = @mixed_step.step_over(:yes)
    @justification = @bad_step.step_over(:no)
  end

  def test_mistake_ratio
    assert_equal 0, @start.new_mistake_ratio(@start)
    assert_equal 0, @start.new_mistake_ratio(@one_right)
    assert_equal 1/3.0, @start.new_mistake_ratio(@mixed_step)
    assert_equal 1/2.0, @start.new_mistake_ratio(@bad_step)
    assert_equal 2/5.0, @start.new_mistake_ratio(@justification)

    assert_equal 0, @one_right.new_mistake_ratio(@start)
    assert_equal 0, @one_right.new_mistake_ratio(@one_right)
    assert_equal 1/2.0, @one_right.new_mistake_ratio(@mixed_step)
    assert_equal 2/3.0, @one_right.new_mistake_ratio(@bad_step)
    assert_equal 1/2.0, @one_right.new_mistake_ratio(@justification)

    assert_equal 1/3.0, @mixed_step.new_mistake_ratio(@start)
    assert_equal 1/2.0, @mixed_step.new_mistake_ratio(@one_right)
    assert_equal 0, @mixed_step.new_mistake_ratio(@mixed_step)
    assert_equal 1, @mixed_step.new_mistake_ratio(@bad_step)
    assert_equal 1/2.0, @mixed_step.new_mistake_ratio(@justification)

    assert_equal 1/2.0, @bad_step.new_mistake_ratio(@start)
    assert_equal 2/3.0, @bad_step.new_mistake_ratio(@one_right)
    assert_equal 1, @bad_step.new_mistake_ratio(@mixed_step)
    assert_equal 0, @bad_step.new_mistake_ratio(@bad_step)
    assert_equal 0, @bad_step.new_mistake_ratio(@justification)

    assert_equal 2/5.0, @justification.new_mistake_ratio(@start)
    assert_equal 1/2.0, @justification.new_mistake_ratio(@one_right)
    assert_equal 1/2.0, @justification.new_mistake_ratio(@mixed_step)
    assert_equal 0, @justification.new_mistake_ratio(@bad_step)
    assert_equal 0, @justification.new_mistake_ratio(@justification)
  end

end
