require 'test/unit'
require 'set'
require File.dirname(__FILE__) + "/set.rb"

class SortedSetTest < Test::Unit::TestCase

  def test_smaller
    set = SortedSet.new([1, 2, 3, 4.5, 5, 7.3])
    assert_equal 1, set.next_smaller(1.1)
    assert_equal 3, set.next_smaller(3.5)
    # TODO rbtree performs <= unconditionally so these fail on khazad-dum
#    assert_equal 4.5, set.next_smaller(5)
#    assert_equal nil, set.next_smaller(1)
    assert_equal 7.3, set.next_smaller(8)
    assert_equal nil, set.next_smaller(-3)
    assert_equal nil, SortedSet.new([]).next_smaller(-3)
  end

  def test_larger
    set = SortedSet.new([1, 2, 3, 4.5, 5, 7.3])
    assert_equal 2, set.next_larger(1.1)
    assert_equal 4.5, set.next_larger(3.5)
    # TODO rbtree performs <=.
#    assert_equal 7.3, set.next_larger(5)
#    assert_equal 2, set.next_larger(1)
    assert_equal nil, set.next_larger(8)
    assert_equal 1, set.next_larger(-3)
    assert_equal nil, SortedSet.new([]).next_larger(-3)
  end

  def test_neighbors
    set = SortedSet.new([1, 2, 3, 4.5, 5, 7.3])
    assert_equal [1, 2], set.neighbors(1.1)
    assert_equal [3, 4.5], set.neighbors(3.5)
    # TODO rbtree performs <=.
#    assert_equal [4.5, 7.3], set.neighbors(5)
#    assert_equal [nil, 2], set.neighbors(1)
    assert_equal [7.3, nil], set.neighbors(8)
    assert_equal [nil, 1], set.neighbors(-3)
    assert_equal [nil, nil], SortedSet.new([]).neighbors(-3)
  end

end
