module TestHelper

  ARTIFICIAL_POINTS = File.dirname(__FILE__) + "/test_data/artificial_points"
  SMALL_DATA_FILE = File.dirname(__FILE__) + "/test_data/few_points"
  NEW_FORMAT_DATA_FILE = File.dirname(__FILE__) + "/test_data/few_points_new_format"
  LEVEL_TEST_DATA_FILE = File.dirname(__FILE__) + "/test_data/level_test_data"
  SMALL_LEVEL_TEST_DATA_FILE = File.dirname(__FILE__) + "/test_data/small_level_test_data"
  JUDGEMENT_REQUESTS = File.dirname(__FILE__) + "/test_data/judgement_requests"
  JUDGEMENT_AND_QRESULT_REQUESTS = File.dirname(__FILE__) + "/test_data/judgement_and_qresult_requests"
  TRAINING_AND_JUDGEMENT_DATA = File.dirname(__FILE__) + "/test_data/training_and_judgement_data"

  def assert_close(expected_thing, given_thing, delta = 1E-07, message = nil)
    case expected_thing
    when Hash: assert_close_hashes expected_thing, given_thing, delta
    when Array: assert_close_arrays expected_thing, given_thing, delta
    when Numeric: assert_in_delta expected_thing, given_thing, delta, message
    else
      assert_equal expected_thing, given_thing, message
    end
  end

  def assert_close_arrays(expected_array, given_array, delta = 1E-07)
    assert_equal expected_array.length, given_array.length, 
    "expected array #{expected_array.inspect} and given array #{given_array.inspect} have different lengths."
    expected_array.length.times do |i|
      assert_close expected_array[i], given_array[i], delta, 
      "expected array #{expected_array.inspect} and given array #{given_array.inspect} differ excessively in element #{i}."
    end
  end

  def assert_close_hashes(expected_hash, given_hash, delta = 1E-07)
    assert_equal expected_hash.keys.sort { |a,b| a.to_s <=> b.to_s }, given_hash.keys.sort { |a,b| a.to_s <=> b.to_s },
    "expected hash #{expected_hash.inspect} and given hash #{given_hash.inspect} have different keysets."
    expected_hash.keys.each do |key|
      assert_close expected_hash[key], given_hash[key], delta,
      "expected hash #{expected_hash.inspect} and given hash #{given_hash.inspect} differ excessively in key #{key}."
    end
  end
end

