#!/usr/bin/perl

die "Not asked to be quiet" unless "--quiet" eq shift @ARGV;
die "Not given answer_keys" unless "--answer_keys" eq shift @ARGV;
shift @ARGV; # Check that answer keys look OK?

die "No training data given" unless -r $ARGV[0];

@training = split("\n", `cat $ARGV[0]`);
#print join("---", @training);
die "Wrong amount of training data given in $ARGV[0]" unless @training == 15;
# This is clearly too strict.  Should I bother parsing out the 
# training data and checking its format?
# die "Training data is not as expected" if `diff $ARGV[0] t/tiny-set/training`;

# Set autoflush on STDOUT
select STDOUT; $| = 1;

while(my $line = <STDIN>) {
    if ($line =~ /^\#?JUDGE_REQUEST/) {
	print STDOUT "NUGGET_PROBS_LIST\t1=>1, 2=>1, 3=>1, 4=>1, 5=>1, 6=>1, 7=>1, 8=>1, 9=>1, 10=>1, 11=>1, 12=>1\n";
    } elsif ($line =~ /^\#?QRESULT_REQUEST/) {
	@answer = (0, # "fake_vital_match",
		   0, # "fake_vital_possible",
		   0, # "fake_okay_match",
		   0, # "fake_okay_possible",
		   0, # "fake_total_match",
		   0, # "fake_total_possible",
		   0, # "fake_length",
		   0, # Fake allowance
		   0, # Fake recall
		   0, # Fake precision
		   0, # Fake F-measure
		   );
	print STDOUT "QRESULT_RESPONSE\t" . join("\t", @answer) . "\n";
    } else {
	close STDOUT;
	die "Invalid input format $_";
    }
}

print STDERR "STDERR Mockery!\n";
